## runc 0.0.8+dfsg

=== Makefile ===
RUNC_TEST_IMAGE=runc_test
PROJECT=github.com/opencontainers/runc
TEST_DOCKERFILE=script/test_Dockerfile
BUILDTAGS=seccomp
export GOPATH:=$(CURDIR)/Godeps/_workspace:$(GOPATH)

all:
	go build -tags "$(BUILDTAGS)" -o runc .

static:
	CGO_ENABLED=1 go build -tags "$(BUILDTAGS) cgo static_build" -ldflags "-w -extldflags -static" -o runc .

vet:
	go get golang.org/x/tools/cmd/vet

lint: vet
	go vet ./...
	go fmt ./...

runctestimage:
	docker build -t $(RUNC_TEST_IMAGE) -f $(TEST_DOCKERFILE) .

test: runctestimage
	docker run -e TESTFLAGS --privileged --rm -v $(CURDIR):/go/src/$(PROJECT) $(RUNC_TEST_IMAGE) make localtest

localtest:
	go test -tags "$(BUILDTAGS)" ${TESTFLAGS} -v ./...


install:
	cp runc /usr/local/bin/runc

clean:
	rm runc

validate: vet
	script/validate-gofmt
	go vet ./...

ci: validate localtest

=== Godeps/_workspace/src/github.com/opencontainers/specs/Makefile ===

DOCKER ?= $(shell which docker)
DOC_FILES := \
	README.md \
	code-of-conduct.md \
	principles.md \
	style.md \
	ROADMAP.md \
	implementations.md \
	bundle.md \
	runtime.md \
	runtime-linux.md \
	config.md \
	config-linux.md \
	glossary.md
EPOCH_TEST_COMMIT := 041eb73d2e0391463894c04c8ac938036143eba3

docs: pdf html
.PHONY: docs

pdf:
	@mkdir -p output/ && \
	$(DOCKER) run \
	-it \
	--rm \
	-v $(shell pwd)/:/input/:ro \
	-v $(shell pwd)/output/:/output/ \
	-u $(shell id -u) \
	vbatts/pandoc -f markdown_github -t latex -o /output/docs.pdf $(patsubst %,/input/%,$(DOC_FILES)) && \
	ls -sh $(shell readlink -f output/docs.pdf)

html:
	@mkdir -p output/ && \
	$(DOCKER) run \
	-it \
	--rm \
	-v $(shell pwd)/:/input/:ro \
	-v $(shell pwd)/output/:/output/ \
	-u $(shell id -u) \
	vbatts/pandoc -f markdown_github -t html5 -o /output/docs.html $(patsubst %,/input/%,$(DOC_FILES)) && \
	ls -sh $(shell readlink -f output/docs.html)

.PHONY: test .govet .golint .gitvalidation

test: .govet .golint .gitvalidation

# `go get golang.org/x/tools/cmd/vet`
.govet:
	go vet -x ./...

# `go get github.com/golang/lint/golint`
.golint:
	golint ./...

# `go get github.com/vbatts/git-validation`
.gitvalidation:
	git-validation -q -run DCO,short-subject -v -range $(EPOCH_TEST_COMMIT)..HEAD

clean:
	rm -rf output/ *~

=== debian/changelog ===
runc (0.0.8+dfsg-2) unstable; urgency=medium

  * (Build-)Depends:
    + golang-github-docker-go-units-dev
    + golang-github-seccomp-libseccomp-golang-dev

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 23 Mar 2016 20:05:01 +1100

runc (0.0.8+dfsg-1) unstable; urgency=medium

  * New upstream release [February 2016].
  * Build-Depends:
    + golang-github-vishvananda-netlink-dev
  * Updated Vcs URLs.
  * Standards-Version: 3.9.7.

 -- Dmitry Smirnov <onlyjob@debian.org>  Fri, 26 Feb 2016 18:19:24 +1100

runc (0.0.4~dfsg-1) unstable; urgency=medium

  * New upstream release (Closes: #802507).
  * Dropped obsolete lintian-overrides.

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 21 Oct 2015 09:02:42 +1100

runc (0.0.3~dfsg2-1) unstable; urgency=low

  * Initial release (Closes: #796486).
    Thanks, Alexandre Viau.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 06 Sep 2015 18:06:34 +1000

=== debian/control ===
Source: runc
Section: devel
Priority: extra
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Alexandre Viau <alexandre@alexandreviau.net>,
           Dmitry Smirnov <onlyjob@debian.org>
Build-Depends: debhelper (>= 9),
               dh-golang,
               help2man,
    golang-codegangsta-cli-dev,
    golang-dbus-dev,
    golang-docker-dev,
    golang-github-coreos-go-systemd-dev,
    golang-github-docker-go-units-dev,
    golang-github-opencontainers-specs-dev,
    golang-github-seccomp-libseccomp-golang-dev,
    golang-github-vishvananda-netlink-dev,
    golang-go,
    golang-gocapability-dev | golang-github-syndtr-gocapability-dev,
    golang-goprotobuf-dev,
    golang-logrus-dev,
    protobuf-compiler
Standards-Version: 3.9.7
Homepage: https://github.com/opencontainers/runc
Vcs-Git: https://anonscm.debian.org/pkg-go/packages/runc.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/runc.git

Package: runc
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: Open Container Project - runtime
 "runc" is a command line client for running applications packaged according
 to the Open Container Format (OCF) and is a compliant implementation of
 the Open Container Project specification.

Package: golang-github-opencontainers-runc-dev
Architecture: all
Depends: ${misc:Depends},
    golang-codegangsta-cli-dev,
    golang-dbus-dev,
    golang-docker-dev,
    golang-github-coreos-go-systemd-dev,
    golang-github-docker-go-units-dev,
    golang-github-opencontainers-specs-dev,
    golang-github-seccomp-libseccomp-golang-dev,
    golang-github-vishvananda-netlink-dev,
    golang-gocapability-dev | golang-github-syndtr-gocapability-dev,
    golang-goprotobuf-dev,
    golang-logrus-dev
Built-Using: ${misc:Built-Using}
Description: Open Container Project - develpoment files
 "runc" is a command line client for running applications packaged according
 to the Open Container Format (OCF) and is a compliant implementation of
 the Open Container Project specification.
 .
 This package provides development files formerly known as
 "github.com/docker/libcontainer".

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DH_GOPKG := github.com/opencontainers/runc

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_clean:
	dh_clean
	## Remove Files-Excluded (when built from checkout or non-DFSG tarball):
	$(RM) -rv `perl -0nE 'say $$1 if m{^Files\-Excluded\:\s*(.*?)(?:\n\n|Files:|Comment:)}sm;' debian/copyright`

override_dh_auto_configure:
	$(MAKE) -C libcontainer/criurpc
	dh_auto_configure
	ln -svrf Godeps/_workspace/src/github.com/opencontainers/specs  _build/src/github.com/opencontainers/

override_dh_auto_test: _build/runc.1
	## Ignoring errors (some tests need network):
	-dh_auto_test

_build/runc.1:
	help2man --no-info _build/bin/runc >"$@"
	[ -s "$@" ] || $(RM) -v "$@"

=== debian/watch ===
version=3

opts=\
repacksuffix=+dfsg,\
dversionmangle=s/[~+]dfsg\d*$// \
 https://github.com/opencontainers/runc/tags \
 .*/v?(\d[\d\.]*)\.tar\.gz

## runc 0.1.0+dfsg1

=== debian/changelog ===
runc (0.1.0+dfsg1-1) unstable; urgency=medium

  * Dropped dependency on "golang-docker-dev" in favour of bundled
    (or build time sub-vendored) "github.com/docker/docker" in order
    to avoid circular dependency with Docker.
  * Standards-Version: 3.9.8.
  * Corrected Vcs-Git URL.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 12 Jun 2016 17:56:45 +1000

runc (0.1.0+dfsg-1) unstable; urgency=medium

  [ Tim Potter ]
  * Team upload
  * New upstream release [April 2016]
    = golang-github-opencontainers-specs-dev (>= 0.5.0~)
  * De-vendor new dependencies; pquerna/ffjson appears unused

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 23 Apr 2016 07:59:18 +1000

runc (0.0.9+dfsg-1) unstable; urgency=medium

  * New upstream release [March 2016].
  * (Build-)Depends:
    = golang-github-opencontainers-specs-dev (>= 0.4.0~)
    = golang-github-codegangsta-cli-dev (>= 0.0~git20151221~)
    - help2man
    + go-md2man
  * Install upstream man pages.
  * Install "runc" binary to "/usr/sbin".

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 16 Apr 2016 17:23:48 +1000

=== debian/control ===
--- 
+++ 
@@ -6,13 +6,13 @@
            Dmitry Smirnov <onlyjob@debian.org>
 Build-Depends: debhelper (>= 9),
                dh-golang,
-               help2man,
-    golang-codegangsta-cli-dev,
+    go-md2man,
     golang-dbus-dev,
-    golang-docker-dev,
+#   golang-github-docker-docker-dev,
+    golang-github-codegangsta-cli-dev (>= 0.0~git20151221~),
     golang-github-coreos-go-systemd-dev,
     golang-github-docker-go-units-dev,
-    golang-github-opencontainers-specs-dev,
+    golang-github-opencontainers-specs-dev (>= 0.5.0~),
     golang-github-seccomp-libseccomp-golang-dev,
     golang-github-vishvananda-netlink-dev,
     golang-go,
@@ -20,9 +20,9 @@
     golang-goprotobuf-dev,
     golang-logrus-dev,
     protobuf-compiler
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Homepage: https://github.com/opencontainers/runc
-Vcs-Git: https://anonscm.debian.org/pkg-go/packages/runc.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-go/packages/runc.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/runc.git
 
 Package: runc
@@ -37,18 +37,18 @@
 Package: golang-github-opencontainers-runc-dev
 Architecture: all
 Depends: ${misc:Depends},
-    golang-codegangsta-cli-dev,
     golang-dbus-dev,
-    golang-docker-dev,
+#  "golang-github-docker-docker-dev" is sub-vendored on build-time to avoid circular dependency with Docker.
+#   golang-github-docker-docker-dev,
+    golang-github-codegangsta-cli-dev (>= 0.0~git20151221~),
     golang-github-coreos-go-systemd-dev,
     golang-github-docker-go-units-dev,
-    golang-github-opencontainers-specs-dev,
+    golang-github-opencontainers-specs-dev (>= 0.4.0~),
     golang-github-seccomp-libseccomp-golang-dev,
     golang-github-vishvananda-netlink-dev,
     golang-gocapability-dev | golang-github-syndtr-gocapability-dev,
     golang-goprotobuf-dev,
     golang-logrus-dev
-Built-Using: ${misc:Built-Using}
 Description: Open Container Project - develpoment files
  "runc" is a command line client for running applications packaged according
  to the Open Container Format (OCF) and is a compliant implementation of

=== debian/rules ===
--- 
+++ 
@@ -15,13 +15,21 @@
 
 override_dh_auto_configure:
 	$(MAKE) -C libcontainer/criurpc
+	cd man && ./md2man-all.sh
 	dh_auto_configure
-	ln -svrf Godeps/_workspace/src/github.com/opencontainers/specs  _build/src/github.com/opencontainers/
+	## Sub-vendor "github.com/docker/docker/pkg" (system lib takes preference over bundled one):
+	mkdir -p _build/src/$(DH_GOPKG)/vendor/github.com/docker/docker
+	if [   -d "/usr/share/gocode/src/github.com/docker/docker/pkg" ]; then \
+            cp -vr /usr/share/gocode/src/github.com/docker/docker/pkg  _build/src/$(DH_GOPKG)/vendor/github.com/docker/docker/ ;\
+        elif [ -d "Godeps/_workspace/src/github.com/docker/docker/pkg" ]; then \
+            cp -vr Godeps/_workspace/src/github.com/docker/docker/pkg  _build/src/$(DH_GOPKG)/vendor/github.com/docker/docker/ ;\
+        fi
+	## Remove extra license files:
+	$(RM) -v \
+            _build/src/$(DH_GOPKG)/vendor/github.com/docker/docker/*/*/LICENSE* \
+        ;
+#	ln -svrf Godeps/_workspace/src/github.com/opencontainers/specs  _build/src/github.com/opencontainers/
 
-override_dh_auto_test: _build/runc.1
+override_dh_auto_test:
 	## Ignoring errors (some tests need network):
 	-dh_auto_test
-
-_build/runc.1:
-	help2man --no-info _build/bin/runc >"$@"
-	[ -s "$@" ] || $(RM) -v "$@"

## runc 0.1.1+dfsg1

=== debian/changelog ===
runc (0.1.1+dfsg1-2+deb9u3) stretch-security; urgency=high

  * CVE-2021-43784: Fix an issue where an overflow in the Netlink 'bytemsg'
    length field could have allowed an attacker to override Netlink-based
    container configurations. This vulnerability required the attacker to have
    some control over the configuration of the container, but would have
    allowed the attacker to bypass the namespace restrictions of the container
    by simply adding their own Netlink payload which disables all namespaces.

 -- Chris Lamb <lamby@debian.org>  Mon, 06 Dec 2021 14:36:50 -0800

runc (0.1.1+dfsg1-2+deb9u2) stretch-security; urgency=medium

  * Non-maintainer upload by the LTS team.
  * Rebuild with golang-github-seccomp-libseccomp-golang that has
    CVE-2017-18367 fixed.

 -- Adrian Bunk <bunk@debian.org>  Mon, 10 Aug 2020 11:35:05 +0300

runc (0.1.1+dfsg1-2+deb9u1) stretch; urgency=medium

  * Team upload.
  * Add patch to address CVE-2019-5736 (Closes: #922050)

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 19 Mar 2019 00:50:07 +0800

runc (0.1.1+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * Backport patch for CVE-2016-9962 (Closes: #850951)

 -- Tianon Gravi <tianon@debian.org>  Wed, 01 Feb 2017 07:17:54 -0800

runc (0.1.1+dfsg1-1) unstable; urgency=medium

  * New upstream release [June 2016].
  * testworks: disabled privileged and failing tests.
  * Build with "apparmor seccomp" tags (Closes: #830818);
    Build-Depends += "libapparmor-dev".

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 13 Jul 2016 23:00:43 +1000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,8 @@
 Priority: extra
 Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
 Uploaders: Alexandre Viau <alexandre@alexandreviau.net>,
-           Dmitry Smirnov <onlyjob@debian.org>
+           Dmitry Smirnov <onlyjob@debian.org>,
+           Tim Potter <tpot@hpe.com>
 Build-Depends: debhelper (>= 9),
                dh-golang,
     go-md2man,
@@ -12,13 +13,14 @@
     golang-github-codegangsta-cli-dev (>= 0.0~git20151221~),
     golang-github-coreos-go-systemd-dev,
     golang-github-docker-go-units-dev,
-    golang-github-opencontainers-specs-dev (>= 0.5.0~),
-    golang-github-seccomp-libseccomp-golang-dev,
+    golang-github-opencontainers-specs-dev (>= 1.0.0~),
+    golang-github-seccomp-libseccomp-golang-dev (>= 0.0~git20150813.0.1b506fc-2+deb9u1~),
     golang-github-vishvananda-netlink-dev,
     golang-go,
     golang-gocapability-dev | golang-github-syndtr-gocapability-dev,
     golang-goprotobuf-dev,
     golang-logrus-dev,
+    libapparmor-dev,
     protobuf-compiler
 Standards-Version: 3.9.8
 Homepage: https://github.com/opencontainers/runc
@@ -43,7 +45,7 @@
     golang-github-codegangsta-cli-dev (>= 0.0~git20151221~),
     golang-github-coreos-go-systemd-dev,
     golang-github-docker-go-units-dev,
-    golang-github-opencontainers-specs-dev (>= 0.4.0~),
+    golang-github-opencontainers-specs-dev (>= 1.0.0~),
     golang-github-seccomp-libseccomp-golang-dev,
     golang-github-vishvananda-netlink-dev,
     golang-gocapability-dev | golang-github-syndtr-gocapability-dev,

## runc 1.0.0~rc1

=== debian/changelog ===
runc (1.0.0~rc1-0ubuntu1) yakkety; urgency=medium

  * Update to 1.0.0-rc1 upstream release
    - remove "lxd--runc-617.patch"; no longer necessary (due to kernel fixes),
      https://github.com/opencontainers/runc/pull/617#issuecomment-223654149
  * Update d/watch to match RCs appropriately

 -- Tianon Gravi <tianon@debian.org>  Wed, 24 Aug 2016 16:29:26 -0700

runc (0.1.1-0ubuntu5) yakkety; urgency=medium

  * Fix "-dev" package Depends, and use vendoring more directly

 -- Tianon Gravi <tianon@debian.org>  Wed, 15 Jun 2016 14:47:50 -0700

runc (0.1.1-0ubuntu4) yakkety; urgency=medium

  * Copy d/patches/lxd--runc-617.patch from docker.io package.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Tue, 14 Jun 2016 09:52:08 +1200

runc (0.1.1-0ubuntu3) yakkety; urgency=medium

  * No change rebuild to pick up s390x fixes.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Fri, 10 Jun 2016 14:42:08 +1200

runc (0.1.1-0ubuntu2) yakkety; urgency=medium

  * Enable apparmor support.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 09 Jun 2016 20:24:57 +1200

runc (0.1.1-0ubuntu1) yakkety; urgency=medium

  * Use bundled dependencies for Ubuntu
  * Update to 0.1.1 upstream release

 -- Tianon Gravi <tianon@debian.org>  Tue, 07 Jun 2016 14:09:28 -0700

=== debian/control ===
Source: runc
Section: devel
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Alexandre Viau <alexandre@alexandreviau.net>,
           Dmitry Smirnov <onlyjob@debian.org>
Build-Depends: debhelper (>= 9),
               dh-golang,
               go-md2man,
               golang-go (>= 2:1.6~) | golang-1.6-go,
               libapparmor-dev
Standards-Version: 3.9.7
Homepage: https://github.com/opencontainers/runc
Vcs-Git: https://anonscm.debian.org/pkg-go/packages/runc.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/runc.git

Package: runc
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: Open Container Project - runtime
 "runc" is a command line client for running applications packaged according
 to the Open Container Format (OCF) and is a compliant implementation of
 the Open Container Project specification.

Package: golang-github-opencontainers-runc-dev
Architecture: all
Depends: ${misc:Depends}
Description: Open Container Project - develpoment files
 "runc" is a command line client for running applications packaged according
 to the Open Container Format (OCF) and is a compliant implementation of
 the Open Container Project specification.
 .
 This package provides development files formerly known as
 "github.com/docker/libcontainer".

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DH_GOPKG := github.com/opencontainers/runc

# prefer Go 1.6 if it's available (golang-1.6-go)
export PATH := /usr/lib/go-1.6/bin:$(PATH)

export DH_GOLANG_EXCLUDES := vendor

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_auto_configure:
	#$(MAKE) -C libcontainer/criurpc
	cd man && ./md2man-all.sh
	dh_auto_configure
	# use vendored deps
	rm -r '_build/src/$(DH_GOPKG)/Godeps/_workspace' \
		&& rm -rf '_build/src/$(DH_GOPKG)/vendor' \
		&& mkdir '_build/src/$(DH_GOPKG)/vendor' \
		&& cd Godeps/_workspace/src \
		&& cp -r . '$(CURDIR)/_build/src/$(DH_GOPKG)/vendor'

# The go tool does not fully support vendoring with gccgo, but we can
# work around that by constructing the appropriate -I flag by hand.
GCCGO := $(shell go tool dist env > /dev/null 2>&1 && echo no || echo yes)

ifeq ($(GCCGO),yes)
GOARCH := $(shell go env GOARCH)
GOOS := $(shell go env GOOS)

override_dh_auto_build:
	dh_auto_build -- -tags apparmor -gccgoflags="-I $(CURDIR)/_build/pkg/gccgo_$(GOOS)_$(GOARCH)/$(DH_GOPKG)/vendor"

override_dh_auto_test:
	-dh_auto_test -- -test.short -gccgoflags="-I $(CURDIR)/_build/pkg/gccgo_$(GOOS)_$(GOARCH)/$(DH_GOPKG)/vendor"
else
override_dh_auto_test:
	## Ignoring errors (some tests need network):
	-dh_auto_test -- -test.short

override_dh_auto_build:
	dh_auto_build -- -tags apparmor
endif

## runc 1.0.0~rc2

=== debian/changelog ===
runc (1.0.0~rc2-0ubuntu2~16.10.1) yakkety; urgency=medium

  * Backport to Yakkety. (LP: #1655906)

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Mon, 30 Jan 2017 12:02:46 +1300

runc (1.0.0~rc2-0ubuntu2) zesty; urgency=medium

  * Add d/patches/0001-nsexec-make-runC-Docker-work-in-unpriv-LXD.patch to fix
    execution in unprivileged containers.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 26 Jan 2017 09:03:23 +1300

runc (1.0.0~rc2-0ubuntu1) zesty; urgency=medium

  * Update to 1.0.0-rc2 upstream release
  * Add patch for CVE-2016-9962 (LP: #1655906)

 -- Tianon Gravi <tianon@debian.org>  Fri, 13 Jan 2017 12:03:21 +1300

runc (1.0.0~rc1-0ubuntu2) zesty; urgency=medium

  [ Tianon Gravi ]
  * Enable seccomp support (LP: #1639407)

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 30 Nov 2016 12:31:01 -0800

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,8 @@
 #export DH_VERBOSE=1
 
 export DH_GOPKG := github.com/opencontainers/runc
+export DH_GOLANG_INSTALL_EXTRA := libcontainer/seccomp/fixtures
+TAGS=apparmor seccomp
 
 # prefer Go 1.6 if it's available (golang-1.6-go)
 export PATH := /usr/lib/go-1.6/bin:$(PATH)
@@ -27,21 +29,17 @@
 # The go tool does not fully support vendoring with gccgo, but we can
 # work around that by constructing the appropriate -I flag by hand.
 GCCGO := $(shell go tool dist env > /dev/null 2>&1 && echo no || echo yes)
-
 ifeq ($(GCCGO),yes)
 GOARCH := $(shell go env GOARCH)
 GOOS := $(shell go env GOOS)
+GCCGOFLAGS := -gccgoflags='-I $(CURDIR)/_build/pkg/gccgo_$(GOOS)_$(GOARCH)/$(DH_GOPKG)/vendor'
+else
+GCCGOFLAGS :=
+endif
 
 override_dh_auto_build:
-	dh_auto_build -- -tags apparmor -gccgoflags="-I $(CURDIR)/_build/pkg/gccgo_$(GOOS)_$(GOARCH)/$(DH_GOPKG)/vendor"
+	dh_auto_build -- -tags '$(TAGS)' $(GCCGOFLAGS)
 
 override_dh_auto_test:
-	-dh_auto_test -- -test.short -gccgoflags="-I $(CURDIR)/_build/pkg/gccgo_$(GOOS)_$(GOARCH)/$(DH_GOPKG)/vendor"
-else
-override_dh_auto_test:
 	## Ignoring errors (some tests need network):
-	-dh_auto_test -- -test.short
-
-override_dh_auto_build:
-	dh_auto_build -- -tags apparmor
-endif
+	-dh_auto_test -- -tags '$(TAGS)' -test.short $(GCCGOFLAGS)

=== debian/watch ===
version=3

opts=\
repacksuffix=+dfsg,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|preview)\d*)$/$1~$2/,\
dversionmangle=s/[~+]dfsg\d*$// \
 https://github.com/opencontainers/runc/tags \
 .*/v?(\d[\d\S]*)\.tar\.gz

## runc 1.0.0~rc2+docker1.12.6

=== debian/changelog ===
runc (1.0.0~rc2+docker1.12.6-0ubuntu1) zesty; urgency=medium

  * Update to the precise commit included in Docker 1.12.6 (LP: #1675288)

 -- Tianon Gravi <tianon@debian.org>  Fri, 24 Mar 2017 14:26:40 -0700

=== debian/watch ===
version=3

opts=\
repacksuffix=+dfsg,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|preview)\d*)$/$1~$2/;\
s/^/1.0.0~rc2+docker/,\
dversionmangle=s/[~+]dfsg\d*$// \
 https://uscan.tianon.xyz/github.com/tianon/docker-runc-tags \
 .*/docker-(\d[\d\S]*)\.tar\.gz

## runc 1.0.0~rc2+docker1.13.1

=== debian/changelog ===
runc (1.0.0~rc2+docker1.13.1-0ubuntu1) artful; urgency=medium

  * Update to Docker 1.13.1's commit
    - refresh patches

 -- Tianon Gravi <tianon@debian.org>  Tue, 22 Aug 2017 09:38:26 -0700

runc (1.0.0~rc2+docker1.12.6-0ubuntu2) artful; urgency=low

  * Ignore systemd unified cgroup2 view.  (LP: #1692912)

 -- Andy Whitcroft <apw@ubuntu.com>  Tue, 23 May 2017 12:42:14 +0100

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,9 @@
                dh-golang,
                go-md2man,
                golang-go (>= 2:1.6~) | golang-1.6-go,
-               libapparmor-dev
+               libapparmor-dev,
+               libseccomp-dev,
+               pkg-config
 Standards-Version: 3.9.7
 Homepage: https://github.com/opencontainers/runc
 Vcs-Git: https://anonscm.debian.org/pkg-go/packages/runc.git

## runc 1.0.0~rc2+git20161109.131.5137186

=== debian/changelog ===
runc (1.0.0~rc2+git20161109.131.5137186-2) unstable; urgency=medium

  * Add Breaks line to binary package to avoid messing up previous 
    Docker installs.

 -- Tim Potter <tpot@hpe.com>  Fri, 24 Feb 2017 09:49:06 +1100

runc (1.0.0~rc2+git20161109.131.5137186-1) unstable; urgency=medium

  * New upstream snapshot.
  * Refresh backported patch for CVE-2016-9962.

 -- Tim Potter <tpot@hpe.com>  Wed, 15 Feb 2017 09:08:52 +1100

=== debian/control ===
Source: runc
Section: devel
Priority: extra
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Alexandre Viau <alexandre@alexandreviau.net>,
           Dmitry Smirnov <onlyjob@debian.org>,
           Tim Potter <tpot@hpe.com>
Build-Depends: debhelper (>= 9),
               dh-golang,
    go-md2man,
    golang-dbus-dev,
#   golang-github-docker-docker-dev,
    golang-github-codegangsta-cli-dev (>= 0.0~git20151221~),
    golang-github-coreos-go-systemd-dev,
    golang-github-docker-go-units-dev,
    golang-github-mrunalp-fileutils-dev,
    golang-github-opencontainers-specs-dev (>= 1.0.0~),
    golang-github-seccomp-libseccomp-golang-dev,
    golang-github-vishvananda-netlink-dev,
    golang-go,
    golang-gocapability-dev | golang-github-syndtr-gocapability-dev,
    golang-goprotobuf-dev,
    golang-logrus-dev,
    libapparmor-dev,
    protobuf-compiler
Standards-Version: 3.9.8
Homepage: https://github.com/opencontainers/runc
Vcs-Git: https://anonscm.debian.org/git/pkg-go/packages/runc.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/runc.git

Package: runc
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: docker.io (<< 1.12)
Built-Using: ${misc:Built-Using}
Description: Open Container Project - runtime
 "runc" is a command line client for running applications packaged according
 to the Open Container Format (OCF) and is a compliant implementation of
 the Open Container Project specification.

Package: golang-github-opencontainers-runc-dev
Architecture: all
Depends: ${misc:Depends},
    golang-dbus-dev,
#  "golang-github-docker-docker-dev" is sub-vendored on build-time to avoid circular dependency with Docker.
#   golang-github-docker-docker-dev,
    golang-github-codegangsta-cli-dev (>= 0.0~git20151221~),
    golang-github-coreos-go-systemd-dev,
    golang-github-docker-go-units-dev,
    golang-github-opencontainers-specs-dev (>= 1.0.0~),
    golang-github-seccomp-libseccomp-golang-dev,
    golang-github-vishvananda-netlink-dev,
    golang-gocapability-dev | golang-github-syndtr-gocapability-dev,
    golang-goprotobuf-dev,
    golang-logrus-dev
Description: Open Container Project - develpoment files
 "runc" is a command line client for running applications packaged according
 to the Open Container Format (OCF) and is a compliant implementation of
 the Open Container Project specification.
 .
 This package provides development files formerly known as
 "github.com/docker/libcontainer".

## runc 1.0.0~rc2+git20170201.133.9df8b30

=== debian/changelog ===
runc (1.0.0~rc2+git20170201.133.9df8b30-2) unstable; urgency=medium

  * Patch to make libcontainer ignore cgroup2 hierarchy. Patch pulled from
    https://github.com/opencontainers/runc/pull/1266.

 -- Vincent Bernat <bernat@debian.org>  Fri, 30 Jun 2017 07:10:34 +0200

runc (1.0.0~rc2+git20170201.133.9df8b30-1) unstable; urgency=medium

  * New upstream snapshot for Docker 1.13.1.

 -- Tim Potter <tpot@hpe.com>  Wed, 24 May 2017 11:36:40 +1000

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DH_GOPKG := github.com/opencontainers/runc
export DH_GOLANG_INSTALL_EXTRA := libcontainer/seccomp/fixtures
TAGS=apparmor seccomp

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_clean:
	dh_clean
	## Remove Files-Excluded (when built from checkout or non-DFSG tarball):
	$(RM) -rv `perl -0nE 'say $$1 if m{^Files\-Excluded\:\s*(.*?)(?:\n\n|Files:|Comment:)}sm;' debian/copyright`

override_dh_auto_configure:
	$(MAKE) -C libcontainer/criurpc
	cd man && ./md2man-all.sh
	dh_auto_configure
	## Sub-vendor "github.com/docker/docker/pkg" (system lib takes preference over bundled one):
	mkdir -p _build/src/$(DH_GOPKG)/vendor/github.com/docker/docker
	if [   -d "/usr/share/gocode/src/github.com/docker/docker/pkg" ]; then \
            cp -vr /usr/share/gocode/src/github.com/docker/docker/pkg  _build/src/$(DH_GOPKG)/vendor/github.com/docker/docker/ ;\
        elif [ -d "Godeps/_workspace/src/github.com/docker/docker/pkg" ]; then \
            cp -vr Godeps/_workspace/src/github.com/docker/docker/pkg  _build/src/$(DH_GOPKG)/vendor/github.com/docker/docker/ ;\
        fi
	## Remove extra license files:
	$(RM) -v \
            _build/src/$(DH_GOPKG)/vendor/github.com/docker/docker/*/*/LICENSE* \
        ;
#	ln -svrf Godeps/_workspace/src/github.com/opencontainers/specs  _build/src/github.com/opencontainers/

override_dh_auto_build:
	dh_auto_build -- -tags "$(TAGS)"

override_dh_auto_test:
	-dh_auto_test -- -tags "$(TAGS)"

## runc 1.0.0~rc4+dfsg1

=== debian/changelog ===
runc (1.0.0~rc4+dfsg1-6) unstable; urgency=medium

  [ Michael Stapelberg ]
  * update debian/gitlab-ci.yml (using salsa.debian.org/go-team/ci/cmd/ci)

  [ Dmitry Smirnov ]
  * Removed myself from uploaders.

  [ Balint Reczey ]
  * Team upload
  * Stop using unix.SIGUNUSED which has been removed from golang.org/x/sys
    (Closes: #889704)

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 10 Apr 2018 18:40:56 +0200

runc (1.0.0~rc4+dfsg1-5) unstable; urgency=medium

  * Vcs-* urls: pkg-go-team -> go-team.

 -- Alexandre Viau <aviau@debian.org>  Mon, 05 Feb 2018 23:05:40 -0500

runc (1.0.0~rc4+dfsg1-4) unstable; urgency=medium

  * Point vcs-* urls to packages subgroup.

 -- Alexandre Viau <aviau@debian.org>  Thu, 25 Jan 2018 15:23:12 -0500

runc (1.0.0~rc4+dfsg1-3) unstable; urgency=medium

  * Change my email to @debian.org.
  * Move to salsa.debian.org.

 -- Alexandre Viau <aviau@debian.org>  Fri, 29 Dec 2017 00:34:59 -0500

runc (1.0.0~rc4+dfsg1-2) unstable; urgency=medium

  * Mark runc breaking docker.io (<= 1.13.1~ds1-2) (Closes: #877146)

 -- Balint Reczey <rbalint@ubuntu.com>  Sat, 30 Sep 2017 11:50:52 -0400

runc (1.0.0~rc4+dfsg1-1) unstable; urgency=medium

  * Team Upload
  * Update watch file to match release candidates
  * Update Files-Excuded and d/control to match dependencies of rc4
  * New upstream release candidate 1.0.0-rc4
  * Drop obsoleted patches
  * Drop outdated README.source
  * Require at least final 1.0.0 release of
    golang-github-opencontainers-specs-dev (Closes: #858250)
  * Fix typo in golang-github-opencontainers-runc-dev package description
    (Closes: #873760)

 -- Balint Reczey <rbalint@ubuntu.com>  Sat, 30 Sep 2017 11:50:50 -0400

runc (1.0.0~rc2+git20170201.133.9df8b30-3) unstable; urgency=medium

  * Replace golang-go with golang-any in Build-Depends

 -- Konstantinos Margaritis <markos@debian.org>  Wed, 09 Aug 2017 15:00:55 +0300

=== debian/control ===
Source: runc
Section: devel
Priority: extra
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Alexandre Viau <aviau@debian.org>,
           Tim Potter <tpot@hpe.com>
Build-Depends: debhelper (>= 9),
               dh-golang,
               go-md2man,
               golang-any,
               golang-dbus-dev,
               golang-github-codegangsta-cli-dev (>= 0.0~git20151221~),
               golang-github-coreos-go-systemd-dev,
               golang-github-coreos-pkg-dev,
#              golang-github-docker-docker-dev,
               golang-github-docker-go-units-dev,
               golang-github-mrunalp-fileutils-dev,
               golang-github-opencontainers-selinux-dev,
               golang-github-opencontainers-specs-dev (>= 1.0.0-0~),
               golang-github-seccomp-libseccomp-golang-dev,
               golang-github-vishvananda-netlink-dev,
               golang-gocapability-dev | golang-github-syndtr-gocapability-dev,
               golang-golang-x-sys-dev (>=0.0~git20170727.0.35ef448-1~),
               golang-goprotobuf-dev,
               golang-logrus-dev,
               libapparmor-dev,
               protobuf-compiler
Standards-Version: 3.9.8
Homepage: https://github.com/opencontainers/runc
Vcs-Git: https://salsa.debian.org/go-team/packages/runc.git
Vcs-Browser: https://salsa.debian.org/go-team/packages/runc

Package: runc
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: docker.io (<= 1.13.1~ds1-2)
Built-Using: ${misc:Built-Using}
Description: Open Container Project - runtime
 "runc" is a command line client for running applications packaged according
 to the Open Container Format (OCF) and is a compliant implementation of
 the Open Container Project specification.

Package: golang-github-opencontainers-runc-dev
Architecture: all
Depends: golang-dbus-dev,
         golang-github-codegangsta-cli-dev (>= 0.0~git20151221~),
         golang-github-coreos-go-systemd-dev,
         golang-github-coreos-pkg-dev,
#        "golang-github-docker-docker-dev" is sub-vendored on build-time to avoid circular dependency with Docker.
#        golang-github-docker-docker-dev,
         golang-github-docker-go-units-dev,
         golang-github-opencontainers-selinux-dev,
         golang-github-opencontainers-specs-dev (>= 1.0.0-0~),
         golang-github-seccomp-libseccomp-golang-dev,
         golang-github-vishvananda-netlink-dev,
         golang-gocapability-dev | golang-github-syndtr-gocapability-dev,
         golang-golang-x-sys-dev (>=0.0~git20170727.0.35ef448-1~),
         golang-goprotobuf-dev,
         golang-logrus-dev,
         ${misc:Depends}
Description: Open Container Project - development files
 "runc" is a command line client for running applications packaged according
 to the Open Container Format (OCF) and is a compliant implementation of
 the Open Container Project specification.
 .
 This package provides development files formerly known as
 "github.com/docker/libcontainer".

=== debian/rules ===
--- 
+++ 
@@ -23,14 +23,14 @@
 	mkdir -p _build/src/$(DH_GOPKG)/vendor/github.com/docker/docker
 	if [   -d "/usr/share/gocode/src/github.com/docker/docker/pkg" ]; then \
             cp -vr /usr/share/gocode/src/github.com/docker/docker/pkg  _build/src/$(DH_GOPKG)/vendor/github.com/docker/docker/ ;\
-        elif [ -d "Godeps/_workspace/src/github.com/docker/docker/pkg" ]; then \
-            cp -vr Godeps/_workspace/src/github.com/docker/docker/pkg  _build/src/$(DH_GOPKG)/vendor/github.com/docker/docker/ ;\
+        elif [ -d "vendor/github.com/docker/docker/pkg" ]; then \
+            cp -vr vendor/github.com/docker/docker/pkg  _build/src/$(DH_GOPKG)/vendor/github.com/docker/docker/ ;\
         fi
 	## Remove extra license files:
 	$(RM) -v \
             _build/src/$(DH_GOPKG)/vendor/github.com/docker/docker/*/*/LICENSE* \
         ;
-#	ln -svrf Godeps/_workspace/src/github.com/opencontainers/specs  _build/src/github.com/opencontainers/
+#	ln -svrf vendor/github.com/opencontainers/specs  _build/src/github.com/opencontainers/
 
 override_dh_auto_build:
 	dh_auto_build -- -tags "$(TAGS)"

## runc 1.0.0~rc6+dfsg1

=== Makefile ===
.PHONY: all shell dbuild man release \
	    localtest localunittest localintegration \
	    test unittest integration \
	    cross localcross

GO := go

SOURCES := $(shell find . 2>&1 | grep -E '.*\.(c|h|go)$$')
PREFIX := $(DESTDIR)/usr/local
BINDIR := $(PREFIX)/sbin
GIT_BRANCH := $(shell git rev-parse --abbrev-ref HEAD 2>/dev/null)
GIT_BRANCH_CLEAN := $(shell echo $(GIT_BRANCH) | sed -e "s/[^[:alnum:]]/-/g")
RUNC_IMAGE := runc_dev$(if $(GIT_BRANCH_CLEAN),:$(GIT_BRANCH_CLEAN))
PROJECT := github.com/opencontainers/runc
BUILDTAGS ?= seccomp
COMMIT_NO := $(shell git rev-parse HEAD 2> /dev/null || true)
COMMIT := $(if $(shell git status --porcelain --untracked-files=no),"${COMMIT_NO}-dirty","${COMMIT_NO}")

MAN_DIR := $(CURDIR)/man/man8
MAN_PAGES = $(shell ls $(MAN_DIR)/*.8)
MAN_PAGES_BASE = $(notdir $(MAN_PAGES))
MAN_INSTALL_PATH := ${PREFIX}/share/man/man8/

RELEASE_DIR := $(CURDIR)/release

VERSION := ${shell cat ./VERSION}

SHELL := $(shell command -v bash 2>/dev/null)

.DEFAULT: runc

runc: $(SOURCES)
	$(GO) build -buildmode=pie $(EXTRA_FLAGS) -ldflags "-X main.gitCommit=${COMMIT} -X main.version=${VERSION} $(EXTRA_LDFLAGS)" -tags "$(BUILDTAGS)" -o runc .

all: runc recvtty

recvtty: contrib/cmd/recvtty/recvtty

contrib/cmd/recvtty/recvtty: $(SOURCES)
	$(GO) build -buildmode=pie $(EXTRA_FLAGS) -ldflags "-X main.gitCommit=${COMMIT} -X main.version=${VERSION} $(EXTRA_LDFLAGS)" -tags "$(BUILDTAGS)" -o contrib/cmd/recvtty/recvtty ./contrib/cmd/recvtty

static: $(SOURCES)
	CGO_ENABLED=1 $(GO) build $(EXTRA_FLAGS) -tags "$(BUILDTAGS) netgo osusergo static_build" -installsuffix netgo -ldflags "-w -extldflags -static -X main.gitCommit=${COMMIT} -X main.version=${VERSION} $(EXTRA_LDFLAGS)" -o runc .
	CGO_ENABLED=1 $(GO) build $(EXTRA_FLAGS) -tags "$(BUILDTAGS) netgo osusergo static_build" -installsuffix netgo -ldflags "-w -extldflags -static -X main.gitCommit=${COMMIT} -X main.version=${VERSION} $(EXTRA_LDFLAGS)" -o contrib/cmd/recvtty/recvtty ./contrib/cmd/recvtty

release:
	script/release.sh -r release/$(VERSION) -v $(VERSION)

dbuild: runcimage
	docker run ${DOCKER_RUN_PROXY} --rm -v $(CURDIR):/go/src/$(PROJECT) --privileged $(RUNC_IMAGE) make clean all

lint:
	$(GO) vet $(allpackages)
	$(GO) fmt $(allpackages)

man:
	man/md2man-all.sh

runcimage:
	docker build ${DOCKER_BUILD_PROXY} -t $(RUNC_IMAGE) .

test:
	make unittest integration rootlessintegration

localtest:
	make localunittest localintegration localrootlessintegration

unittest: runcimage
	docker run ${DOCKER_RUN_PROXY} -t --privileged --rm -v /lib/modules:/lib/modules:ro -v $(CURDIR):/go/src/$(PROJECT) $(RUNC_IMAGE) make localunittest TESTFLAGS=${TESTFLAGS}

localunittest: all
	$(GO) test -timeout 3m -tags "$(BUILDTAGS)" ${TESTFLAGS} -v $(allpackages)

integration: runcimage
	docker run ${DOCKER_RUN_PROXY} -t --privileged --rm -v /lib/modules:/lib/modules:ro -v $(CURDIR):/go/src/$(PROJECT) $(RUNC_IMAGE) make localintegration TESTPATH=${TESTPATH}

localintegration: all
	bats -t tests/integration${TESTPATH}

rootlessintegration: runcimage
	docker run ${DOCKER_RUN_PROXY} -t --privileged --rm -v $(CURDIR):/go/src/$(PROJECT) $(RUNC_IMAGE) make localrootlessintegration

localrootlessintegration: all
	tests/rootless.sh

shell: runcimage
	docker run ${DOCKER_RUN_PROXY} -ti --privileged --rm -v $(CURDIR):/go/src/$(PROJECT) $(RUNC_IMAGE) bash

install:
	install -D -m0755 runc $(BINDIR)/runc

install-bash:
	install -D -m0644 contrib/completions/bash/runc $(PREFIX)/share/bash-completion/completions/runc

install-man:
	install -d -m 755 $(MAN_INSTALL_PATH)
	install -m 644 $(MAN_PAGES) $(MAN_INSTALL_PATH)

uninstall:
	rm -f $(BINDIR)/runc

uninstall-bash:
	rm -f $(PREFIX)/share/bash-completion/completions/runc

uninstall-man:
	rm -f $(addprefix $(MAN_INSTALL_PATH),$(MAN_PAGES_BASE))

clean:
	rm -f runc runc-*
	rm -f contrib/cmd/recvtty/recvtty
	rm -rf $(RELEASE_DIR)
	rm -rf $(MAN_DIR)

validate:
	script/validate-gofmt
	script/validate-c
	$(GO) vet $(allpackages)

ci: validate test release

cross: runcimage
	docker run ${DOCKER_RUN_PROXY} -e BUILDTAGS="$(BUILDTAGS)" --rm -v $(CURDIR):/go/src/$(PROJECT) $(RUNC_IMAGE) make localcross

localcross:
	CGO_ENABLED=1 GOARCH=arm GOARM=6 CC=arm-linux-gnueabi-gcc $(GO) build -buildmode=pie $(EXTRA_FLAGS) -ldflags "-X main.gitCommit=${COMMIT} -X main.version=${VERSION} $(EXTRA_LDFLAGS)" -tags "$(BUILDTAGS)" -o runc-armel .
	CGO_ENABLED=1 GOARCH=arm GOARM=7 CC=arm-linux-gnueabihf-gcc $(GO) build -buildmode=pie $(EXTRA_FLAGS) -ldflags "-X main.gitCommit=${COMMIT} -X main.version=${VERSION} $(EXTRA_LDFLAGS)" -tags "$(BUILDTAGS)" -o runc-armhf .
	CGO_ENABLED=1 GOARCH=arm64 CC=aarch64-linux-gnu-gcc $(GO) build -buildmode=pie $(EXTRA_FLAGS) -ldflags "-X main.gitCommit=${COMMIT} -X main.version=${VERSION} $(EXTRA_LDFLAGS)" -tags "$(BUILDTAGS)" -o runc-arm64 .
	CGO_ENABLED=1 GOARCH=ppc64le CC=powerpc64le-linux-gnu-gcc $(GO) build -buildmode=pie $(EXTRA_FLAGS) -ldflags "-X main.gitCommit=${COMMIT} -X main.version=${VERSION} $(EXTRA_LDFLAGS)" -tags "$(BUILDTAGS)" -o runc-ppc64le .

# memoize allpackages, so that it's executed only once and only if used
_allpackages = $(shell $(GO) list ./... | grep -v vendor)
allpackages = $(if $(__allpackages),,$(eval __allpackages := $$(_allpackages)))$(__allpackages)

=== debian/changelog ===
runc (1.0.0~rc6+dfsg1-3) unstable; urgency=medium

  * Team upload.

  [ Shengjing Zhu ]
  * Improve patch for CVE-2019-5736 based on upstream commits.
    Now the patch includes following commits:
    + 2d4a37b nsenter: cloned_binary: userspace copy fallback if sendfile fails
    + 16612d7 nsenter: cloned_binary: try to ro-bind /proc/self/exe before
              copying
    + af9da0a nsenter: cloned_binary: use the runc statedir for O_TMPFILE
    + 2429d59 nsenter: cloned_binary: expand and add pre-3.11 fallbacks
    + 5b775bf nsenter: cloned_binary: detect and handle short copies
    + bb7d8b1 nsexec (CVE-2019-5736): avoid parsing environ
    + 0a8e411 nsenter: clone /proc/self/exe to avoid exposing host binary to
              container

  [ Arnaud Rebillout ]
  * Add version and gitcommit to the ldflags (Closes: #909644)
    Note that we fill the git commit with something that is NOT a git commit
    at all, instead we use it as a placeholder for the debian version. The
    debian version is a relevant information for the user, and it's nice to
    be able to show it, some way or another.

 -- Shengjing Zhu <zhsj@debian.org>  Sun, 10 Mar 2019 17:51:44 +0800

runc (1.0.0~rc6+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * Apply upstream patch addressing CVE-2019-5736 (Closes: #922050)
    Thanks Noah Meyerhans!

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 12 Feb 2019 23:45:09 +0800

runc (1.0.0~rc6+dfsg1-1) unstable; urgency=medium

  * Standards-Version: 4.3.0.
  * New upstream release.

 -- Dmitry Smirnov <onlyjob@debian.org>  Fri, 25 Jan 2019 07:55:34 +1100

runc (1.0.0~rc5+dfsg1-4) unstable; urgency=medium

  * New patch to disable Hugetlb tests.

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 27 Sep 2018 08:16:11 +1000

runc (1.0.0~rc5+dfsg1-3) unstable; urgency=medium

  * TAGS += ambient
  * New patch to fix FTBFS on mips* architectures.

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 18 Jun 2018 11:47:25 +1000

runc (1.0.0~rc5+dfsg1-2) unstable; urgency=medium

  * New patch to fix integer overflow on i686.
  * Build with "selinux" tag (Closes: #865993).
    Thanks, Laurent Bigonville.
  * Added myself to uploaders.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 16 Jun 2018 22:12:23 +1000

runc (1.0.0~rc5+dfsg1-1) unstable; urgency=medium

  * Team upload.

  [ Arnaud Rebillout ]
  * Set minimum requirement for golang-gocapability-dev.
    And drop the alternative name golang-github-syndtr-gocapability-dev,
    this name never existed in the first place.

  [ Dmitry Smirnov ]
  * New upstream release
  * Testsuite: autopkgtest-pkg-go
  * Standards-Version: 4.1.4; Priority: optional
  * debhelper to version 11; compat to version 10.
  * Added "XS-Go-Import-Path".
  * (Build-)Depends:
    - golang-github-codegangsta-cli-dev
    - golang-github-coreos-pkg-dev
    - golang-golang-x-sys-dev
    - golang-logrus-dev
    + golang-github-containerd-console-dev
    + golang-github-pkg-errors-dev
    + golang-github-sirupsen-logrus-dev
    + golang-github-urfave-cli-dev

 -- Dmitry Smirnov <onlyjob@debian.org>  Fri, 15 Jun 2018 21:48:18 +1000

=== debian/control ===
Source: runc
Section: devel
Priority: optional
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Alexandre Viau <aviau@debian.org>, Dmitry Smirnov <onlyjob@debian.org>,
           Tim Potter <tpot@hpe.com>
Build-Depends: debhelper (>= 11~),
               dh-golang,
               go-md2man,
               golang-any,
               golang-dbus-dev,
               golang-github-containerd-console-dev,
               golang-github-coreos-go-systemd-dev,
               golang-github-docker-go-units-dev,
               golang-github-mrunalp-fileutils-dev,
               golang-github-opencontainers-selinux-dev,
               golang-github-opencontainers-specs-dev (>= 1.0.1-5~),
               golang-github-pkg-errors-dev,
               golang-github-seccomp-libseccomp-golang-dev,
               golang-github-sirupsen-logrus-dev (>= 1.0.2~),
               golang-github-urfave-cli-dev,
               golang-github-vishvananda-netlink-dev,
               golang-gocapability-dev (>= 0.0~git20160928~),
               golang-goprotobuf-dev,
               libapparmor-dev,
               protobuf-compiler
Standards-Version: 4.3.0
Homepage: https://github.com/opencontainers/runc
Vcs-Git: https://salsa.debian.org/go-team/packages/runc.git
Vcs-Browser: https://salsa.debian.org/go-team/packages/runc
XS-Go-Import-Path: github.com/opencontainers/runc
Testsuite: autopkgtest-pkg-go

Package: runc
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: docker.io (<= 1.13.1~ds1-2)
Built-Using: ${misc:Built-Using}
Description: Open Container Project - runtime
 "runc" is a command line client for running applications packaged according
 to the Open Container Format (OCF) and is a compliant implementation of
 the Open Container Project specification.

Package: golang-github-opencontainers-runc-dev
Architecture: all
Depends: ${misc:Depends},
         golang-dbus-dev,
         golang-github-coreos-go-systemd-dev,
         golang-github-docker-go-units-dev,
         golang-github-opencontainers-selinux-dev,
         golang-github-opencontainers-specs-dev (>= 1.0.1-5~),
         golang-github-seccomp-libseccomp-golang-dev,
         golang-github-sirupsen-logrus-dev (>= 1.0.2~),
         golang-github-urfave-cli-dev,
         golang-github-vishvananda-netlink-dev,
         golang-gocapability-dev (>= 0.0~git20160928~),
         golang-goprotobuf-dev
Description: Open Container Project - development files
 "runc" is a command line client for running applications packaged according
 to the Open Container Format (OCF) and is a compliant implementation of
 the Open Container Project specification.
 .
 This package provides development files formerly known as
 "github.com/docker/libcontainer".

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DH_GOPKG := github.com/opencontainers/runc
export DH_GOLANG_INSTALL_EXTRA := libcontainer/seccomp/fixtures

include /usr/share/dpkg/pkg-info.mk

TAGS=apparmor seccomp selinux ambient
LDFLAGS := -X main.version=$(DEB_VERSION_UPSTREAM) -X main.gitCommit=$(DEB_VERSION)

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_clean:
	dh_clean
	## Remove Files-Excluded (when built from checkout or non-DFSG tarball):
	$(RM) -rv `perl -0nE 'say $$1 if m{^Files\-Excluded\:\s*(.*?)(?:\n\n|Files:|Comment:)}sm;' debian/copyright`

override_dh_auto_configure:
	$(MAKE) -C libcontainer/criurpc
	cd man && ./md2man-all.sh
	dh_auto_configure
#	## Sub-vendor "github.com/docker/docker/pkg" (system lib takes preference over bundled one):
#	mkdir -p _build/src/$(DH_GOPKG)/vendor/github.com/docker/docker
#	if [   -d "/usr/share/gocode/src/github.com/docker/docker/pkg" ]; then \
#            cp -vr /usr/share/gocode/src/github.com/docker/docker/pkg  _build/src/$(DH_GOPKG)/vendor/github.com/docker/docker/ ;\
#        elif [ -d "vendor/github.com/docker/docker/pkg" ]; then \
#            cp -vr vendor/github.com/docker/docker/pkg  _build/src/$(DH_GOPKG)/vendor/github.com/docker/docker/ ;\
#        fi
	## Remove extra license files:
	$(RM) -v \
            _build/src/$(DH_GOPKG)/vendor/github.com/docker/docker/*/*/LICENSE* \
        ;
#	ln -svrf vendor/github.com/opencontainers/specs  _build/src/github.com/opencontainers/

override_dh_auto_build:
	dh_auto_build -- -tags "$(TAGS)" -ldflags "$(LDFLAGS)"

override_dh_auto_test:
	DH_GOLANG_EXCLUDES="libcontainer/integration" \
        dh_auto_test -- -tags "$(TAGS)"
